int nodeid;                               // Переменная ID ноды, значения от 1 до 254
int channelid;                            // Переменная канал ноды, значения от 0 до 124
int error;                                // Переменная ошибки связи, значения от 1 до 254 (при 255 происходит сброс в 0)
byte fflag_ch;                            // Переменная установлен ли канал связи, значения 0 или 1
byte count;                               // Переменная счетчик попыток отправки

//#define MY_DEBUG                        // Если нужен вывод отладочных сообщений Mysensor - раскомментировать
//#define SERIAL_DEBUG                    // Если нужен вывод своих отладочных сообщений - раскомментировать
#define MY_RADIO_NRF24                    // Используемый радиомодуль
#define MY_RF24_CHANNEL channelid         // Установка канала (частоты) связи, по умолчанию 76
#define MY_TRANSPORT_WAIT_READY_MS 10000  // Время ожидания в мс, для установки соединения с гейтом
#define MY_PARENT_NODE_ID 0               // Родитель для этой ноды
#define MY_PARENT_NODE_IS_STATIC          // В случае если родитель пропал не ищем другого

#include <MySensors.h>                    // Подключаем библиотеку MySensors
#include <Bounce2.h>                      // Подключаем библиотеку обработки кнопок
#include <avr/wdt.h>                      // Подключаем библиотеку Сброса при зависании

#define SKETCH_NAME "Vannaya_16MHz"       // Версия скетча
#define SKETCH_MAJOR_VER "10.02"
#define SKETCH_MINOR_VER "18"

#define LONGPRESS 1000                    // Определим задержку для длинного нажатия 1 секунда

// Id сенсоры ноды (0-254)
#define CH 3                              // Колличество каналов реле (кнопок)
#define Num 9                             // Колличество передаваемых сообщений реле (каналов) на шлюз
#define ERR_ID 252                        // Канал, количество ошибок связи
#define NCHANNEL_ID 253                   // Канал, номер канала NRF24
#define NODE_ID 254                       // Канал, ID ноды

// Создадим структуру для хранения параметров "канала"
typedef struct {
  int button;                             // пин кнопки
  int relay;                              // пин реле
  boolean state;                          // Состояние реле (также сохраняется в EEPROM)
  unsigned long power_on;                 // время, когда нагрузка была включена
  unsigned long auto_off;                 // время, через которое нагрузку автоматически выключить
  unsigned long timer;                    // MySwitch[0].timer - время до автоматического включения вытяжки (после включения света)
                                          // MySwitch[1].timer - время до автоматического выключения вытяжки (после выключения света)
                                          // MySwitch[2].timer - время не установлено
  unsigned long time_off;                 // время, автовыключения 
  boolean autostate;                      // флаг, означающий, что ждем автовыключение 
  unsigned long press_start;              // время, когда кнопку нажали
  unsigned long press_stop;               // время, когда кнопку отпустили
}
Channel;

// Определим (установим) параметры каналов
// MySwitch[0]. - канал освещения ванной
// MySwitch[1]. - канал вытяжки ванной
// MySwitch[2]. - канал освещения прихожей
// button, relay, state, power_on, auto_off, timer, time_off, autostate, press_start, press_stop
Channel MySwitch[CH] = {
  14, 4, LOW, 0, 0, 0, 0, false, 0, 0,
  15, 5, LOW, 0, 0, 0, 0, false, 0, 0,
  16, 6, LOW, 0, 0, 0, 0, false, 0, 0
};

// Флаг для дополнительной логики отключен
boolean logicFlag = false;                // Определим переменные (присвоим имя переменным),
boolean onFlag = false;                   // значения true/false (правда/ложь)
boolean offFlag = false;

Bounce debouncer[CH];
MyMessage msg[Num];                       // Инициализировать сообщения 
MyMessage msgCH(NCHANNEL_ID, V_STATUS);
MyMessage msgID(NODE_ID, V_STATUS);
MyMessage msgERR(ERR_ID, V_VAR3);

//*************Функция MySensors выполняется самая первая**************

void before()
{
  if (hwReadConfig(EEPROM_NODE_ID_ADDRESS) == 0) // Если в первой (0) ячейке EEPROM записан ноль
  {
    hwWriteConfig(EEPROM_NODE_ID_ADDRESS, 255);  // Запишем туда 255
  }
  channelid = loadState(200);                   // Установим (прочтем) значение из ячейки 613
  fflag_ch = loadState(201);                    // Установим (прочтем) значение из ячейки 614
  error = loadState(202);                       // Установим (прочтем) значение из ячейки 615
  delay(20);
  if (fflag_ch == 255)                          // Если значение равно 255
  {
    fflag_ch = 0;                               // Установим значение в ноль
    saveState(201, fflag_ch);                   // Сохраним значение в ячейку 614
  }

  if (fflag_ch == 1)                            // Если значение fflag_ch равно 1
  {
    if (channelid > 125)                        // И если значение channelid больше 125 
    {
      channelid = 76;                           // Установим значение channelid 76
      error = 0;                                // Установим значение error 0
      saveState(200, channelid);                // Сохраним установленое значение в ячейку 613
      saveState(202, error);                    // Сохраним установленое значение в ячейку 615
    }
  }

  if (fflag_ch == 0)                            // Если значение fflag_ch равно 0
  {
      channelid = 76;                           // Установим значение channelid 76
      saveState(200, channelid);                // Сохраним установленое значение в ячейку 613
      #ifdef SERIAL_DEBUG                       // Если раскомментирован #define SERIAL_DEBUG
      Serial.print("#################### -------------------------------->>> ");
      Serial.println(channelid);                // Отправим в сериал порт установленное значение channelid
      Serial.print(" <<<-------------------------------- ####################");
      #endif
    }
  if (error >= 255)                             // Если количество ошибок больше или равно 255
  {
    error = 0;                                  // Установим значение error 0
    saveState(202, error);                      // Очистим ячейки 615, запишем 0
    saveState(203, error);                      // Очистим ячейки 617, запишем 0
  }
}

//*******************Функция презентации MySensors*********************

void presentation()
{
  sendSketchInfo(SKETCH_NAME, SKETCH_MAJOR_VER"."SKETCH_MINOR_VER); // Отправить версию скетча
  wait(20);
  present(0, S_LIGHT, "Relay 1");               // Представить типы датчиков на шлюз
  present(1, S_LIGHT, "Relay 2");
  present(2, S_LIGHT, "Relay 3");
  present(3, S_CUSTOM, "auto_off1");
  present(4, S_CUSTOM, "auto_off2");
  present(5, S_CUSTOM, "auto_off3");
  present(6, S_CUSTOM, "timer1");
  present(7, S_CUSTOM, "timer2");
  present(8, S_CUSTOM, "timer3");
  present(ERR_ID, S_CUSTOM, "Error send");
  present(NCHANNEL_ID, S_BINARY, "Chanel NRF24");
  present(NODE_ID, S_BINARY, "ID Node");
  wait(20);
  send(msgERR.set(error));                      // Отправить количество ошибок (отправляет только при работе),
}                                               // во время первого включения НЕТ.

//*************************Функция установок***************************

void setup()
{
  wdt_disable();                                // Бесполезная строка до которой не доходит выполнение при bootloop

  transportSwitchSM(stReady);                   // Запуск транспорта MySensors принудительно
  
  if (fflag_ch == 1)                            // Если флаг установлен в один
  {
    nodeid = hwReadConfig(EEPROM_NODE_ID_ADDRESS); // Считываем параметр с ячейки 0
    send(msgCH.set(channelid));                 // Отправим номер канала
    wait(200);                                  // Подождем ответа 200 мс
    send(msgID.set(nodeid));                    // Отправим ID ноды
    wait(200);                                  // Подождем ответа 200 мс
  #ifdef SERIAL_DEBUG                           // Если раскомментирован #define SERIAL_DEBUG
  Serial.println("####################################");
  Serial.print("################### --- >  CHANNEL = ");
  Serial.println(channelid);                    // Отправим в сериал порт значение channelid
  Serial.print("################### --- >  NODE ID = ");
  Serial.println(nodeid);                       // Отправим в сериал порт значение nodeid
  Serial.println("####################################");
  #endif
  
  for (int i = 0; i < CH; i++)                  // Инициализировать реле и соответствующие кнопки по каналам 0-2
  {
    msg[i].sensor = i;                          // Инициализировать сообщения реле
    msg[i].type = V_STATUS;                     // Установим тип данных, сообщений датчика
    debouncer[i] = Bounce();                    // Инициализировать debouncer
    debouncer[i].attach(MySwitch[i].button);
    debouncer[i].interval(5);
    pinMode(MySwitch[i].button, INPUT_PULLUP);  // Установка входа кнопок и включение подтяжки (1)
    pinMode(MySwitch[i].relay, OUTPUT);         // Установка выхода реле
    MySwitch[i].state = loadState(i);           // Извлечь последние значения из EEPROM
    digitalWrite(MySwitch[i].relay, MySwitch[i].state); // И соответственно установить реле вкл/выкл
    send(msg[i].set(MySwitch[i].state));        // Информировать шлюз о последнем статусе
    wait(200);                                  // Подождем ответа 200 мс
  }
  for (int i = 0; i < CH; i++)                  // Инициализировать таймеры "auto_off" по каналам 3-5
  {
    msg[i+CH].sensor = i+CH;                    // Инициализировать сообщения таймеров "auto_off"
    msg[i+CH].type = V_WEIGHT;                  // Установим тип данных, сообщений датчика
    MySwitch[i].auto_off = loadState(i+CH);     // Извлечь последние значения из EEPROM
    send(msg[i+CH].set(MySwitch[i].auto_off));  // Информировать шлюз об установленном времени в минутах
    wait(200);                                  // Подождем ответа 200 мс
  }
   for (int i = 0; i < CH; i++)                 // Инициализировать таймеры "timer" по каналам 6-8
   {
    msg[i+CH+CH].sensor = i+CH+CH;              // Инициализировать сообщения таймеров "timer"
    msg[i+CH+CH].type = V_FLOW;                 // Установим тип данных, сообщений датчика
    MySwitch[i].timer = loadState(i+CH+CH);     // Извлечь последние значения из EEPROM
    send(msg[i+CH+CH].set(MySwitch[i].timer));  // Информировать шлюз об установленном времени в минутах
    wait(200);                                  // Подождем ответа 200 мс
  }
  
  #ifdef SERIAL_DEBUG
  Serial.begin(115200);
  Serial.println("Ready!");
  #endif
  
wdt_enable (WDTO_8S);                           // Устанавливаем значение ожидания сторожевой собаки 8 сек.
  }
}

//*******************Функция основного процесса************************

void loop()
{
    wdt_reset();                                // Сбросим сторожевую собаку
  
  if (fflag_ch == 0)                            // Если флаг установлен в ноль
  {
    int hd = transportGetDistanceGW();
    wait(100);                                  // Ждем 100 мс
    if ((hd == 255) || (hd == 0))               // Если значение равно 255 или равно 0
    {
      softReset();                              // Перезагрузка
    }
    else
    {
      fflag_ch = 1;
      saveState(201, fflag_ch);                 // Сохраним значение в ячейку 614
      wait(500);                                // Ждем 500 мс
      softReset();                              // Перезагрузка
    }
  }

  if (fflag_ch == 1)                            // Если флаг установлен в один
  {
  // Работаем с кнопками
  button_read();                                // переход в функцию "button_read()"

  // Отработаем автовыключение
  autoOff();                                    // переход в функцию "autoOff()"

  // Проверим дополнительную логику работы
  chkLogic();                                   // переход в функцию "chkLogic()"
  }
}

//******************Функция обработки нажатия кнопок*******************

void  button_read()
{
for (byte i = 0; i < CH; i++)                   // Цикл по всем каналам
{
    if ( debouncer[i].update() )                // Если изменилось состояние входа с кнопки
    {
      if ( debouncer[i].read() == LOW)          // Если это состояние низкое (0)
      {
        MySwitch[i].press_start = millis();     // Фиксируем время старта нажатия
      }
      else
      {                                         // Переход в функцию "void pressDetect", с параметрами
        pressDetect(i, millis());               // Для определения, какое нажатие было (короткое или длинное)
      }
    }
  }
}

//*********************************************************************
// Функция реализации выключателя, отрабатывает строку вида "doSwitch(i, LOW);"

void doSwitch(int ch, boolean state)
{
  MySwitch[ch].state = state;                   // Устанавливаем требуемое состояние выключателя
  saveState( ch, MySwitch[ch].state );          // Сохранить состояние датчика в EEPROM (положение == номер датчика)
  bool send_data = send(msg[ch].set(MySwitch[ch].state)); // Отправить состояние на шлюз
  wait(100);
      if (send_data == 1)                       // Если сообщение отправлено
      {
        #ifdef SERIAL_DEBUG
        Serial.println("Message sent OK");      // Вывести в сериал "Сообщение отправлено"
        #endif
        }
        else
        {
  while (send_data == 0)                        // Пока статус отправки ложь
  {
      count++;                                  // Включаем счётчик
      #ifdef SERIAL_DEBUG
      Serial.print("Sending a message, try No."); // Выводим в монитор порта попытку отправки
      Serial.println(count);                    // и её номер
      #endif
      send_data = send(msg[ch].set(MySwitch[ch].state)); // Отправляем сообщение
      wait(100, 1, V_STATUS);                   // Ждём подтверждения отправки
      if (send_data == 1)                       // Если сообщение отправлено
      {
        count = 0;
        #ifdef SERIAL_DEBUG
        Serial.println("Message sent, OK");     // Вывести в сериал "Сообщение отправлено"
        #endif
      }
      if ((count == 2 )&&(send_data == 0))      // Если сделано 3 попытки и нет подтверждения отправки
      {
        count = 0;                              // Обнуляем счётчик
        send_data = 1;                          // Выходим из цикла
        error ++;
        saveState(202, error);
        #ifdef SERIAL_DEBUG
        Serial.println("Send failed, NG");      // Выводим сообщение "Отправка не удалась"
        Serial.print("ERROR - ");
        Serial.println(error);                  // Выводим количество неудавшихся отправок
        #endif
      }
    }
  }
  if (MySwitch[ch].state == HIGH)               // Если выключатель перешел в состояние "ВКЛ" (1)
  {
    MySwitch[ch].power_on = millis();           // Зафиксируем время перехода
                                                // И если время автоотключения больше нуля и не равно нулю
    if((MySwitch[ch].auto_off > 0) && (MySwitch[ch].auto_off != 0)) {
                                                // Посчитаем время, когда надо будет автоматически выключить
      MySwitch[ch].time_off = MySwitch[ch].power_on + MySwitch[ch].auto_off*60000;
      MySwitch[ch].autostate = true;            // Переведем флаг автовыключения в "true"
    }
    #ifdef SERIAL_DEBUG
    Serial.print("ON ch ");
    Serial.println(ch);
    #endif
  }
  else {                                        // Если выключатель в положение "ВЫКЛ"
    MySwitch[ch].autostate = false;             // Отключим режим автовыключения
    MySwitch[ch].time_off = 0;                  // Сбросим время автовыключения
    #ifdef SERIAL_DEBUG
    Serial.print("OFF ch ");
    Serial.println(ch);
    #endif
  }
  digitalWrite(MySwitch[ch].relay,MySwitch[ch].state); // Установим выход реле в требуемое состояние
}

//**********************Функция автовыключения*************************

void autoOff()
{
  for (int i=0; i < CH; i++) {                  // Цикл по всем каналам
                                                // Если время выключения подошло - щелкнем выключателем
    if ((millis() >= MySwitch[i].time_off) && MySwitch[i].autostate)
    {
      MySwitch[i].autostate = false;            // Отключим режим автовыключения
      doSwitch(i, LOW);                         // Переход в функцию "doSwitch", с параметрами
      #ifdef SERIAL_DEBUG
      Serial.print("Auto OFF ");
      Serial.println(i);
      #endif
    }
  }
}

//*********************************************************************

// Функция определения длинны нажатия на клавишу и выполняем действия
void pressDetect(int ch, unsigned long p_stop)
{
  if  (MySwitch[ch].press_start != 0)
  {
    if (((p_stop-MySwitch[ch].press_start) < LONGPRESS) && (p_stop-MySwitch[ch].press_start) > 0)
    {
      MySwitch[ch].press_stop = p_stop;         // Короткое нажатие
      #ifdef SERIAL_DEBUG
      Serial.print("Short press ch ");
      Serial.println(ch);
      #endif
      // Отправляем в функцию "doSwitch", выключатель "ch", состояние вкл/выкл
      doSwitch(ch, MySwitch[ch].state ? LOW : HIGH);
      }
    else {                                      // Длинное нажатие
      #ifdef SERIAL_DEBUG
      Serial.print("Long press ch ");
      Serial.println(ch);
      #endif
      doSwitch(2, MySwitch[2].state ? LOW : HIGH); // Отправляем состояние вкл/выкл выключателем прихожей 
      saveState( 2, MySwitch[2].state );        // Сохранить состояние датчика в EEPROM (положение == номер датчика)
    }
  }
}

//*********************************************************************

// Функция дополнительной логики работы
void chkLogic()
{
  /* дополнительная логика (для с/у)
   
   0-канал - свет с/у
   1-канал - вытяжка с/у
   
   если 0 канал включен больше, чем 1.5 минуты (время установленное в MySwitch[0].timer), то нужно включить и 1 канал.
   после выключение 0 канала - 1 канал выключить через 5 минут (время установленное в MySwitch[1].timer)
   */

  // Если свет горит больше заданного интервала (параметр MySwitch[0].timer и он - ненулевой), а вытяжка не включена - нужно включить вытяжку
  if ((onFlag == false) && (millis() > (MySwitch[0].power_on + MySwitch[0].timer*60000)) && (MySwitch[0].timer != 0) && (MySwitch[0].state == HIGH) && (MySwitch[1].state == LOW) && (MySwitch[1].press_stop < MySwitch[0].power_on))
  {
    doSwitch(1, HIGH);                          // Включаем вытяжку
    onFlag = true;                              // Взводим флаг автовключения
    logicFlag = true;
    MySwitch[1].autostate = false;              // Выключаем режим автовыключения по таймауту
    #ifdef SERIAL_DEBUG
    Serial.println("Auto Logic ON");
    #endif
  }

  // Если вытяжка включена - дадим ей новое время выключения - через заданный интервал ((параметр MySwitch[1].timer и он - ненулевой) после выключения света
  if ((logicFlag == true) && (offFlag == false) && (MySwitch[1].timer != 0) && (MySwitch[1].state == HIGH) && (MySwitch[0].state == LOW))
  {
    MySwitch[1].time_off = millis() + MySwitch[1].timer*60000;
    MySwitch[1].autostate = true;
    offFlag = true;
    #ifdef SERIAL_DEBUG
    Serial.println("Auto Logic OFF started");
    #endif
  }

  // Если все выключено, сбрасываем все флаги
  if ((logicFlag == true) && (MySwitch[0].state == LOW) && (MySwitch[1].state == LOW))
  {
    offFlag = false;
    onFlag = false;
    logicFlag = false;

    #ifdef SERIAL_DEBUG
    Serial.println("Logic reset");
    #endif
  }

  // Если при включенной вытяжке выключатель выключили вручную - запускаем автовыключение вытяжки
  if ((logicFlag == false) && (offFlag == false) && (MySwitch[0].press_stop > MySwitch[1].power_on) && (MySwitch[1].state == HIGH) && (MySwitch[0].state == LOW))
  {
    logicFlag = true;
    #ifdef SERIAL_DEBUG
    Serial.println("Auto OFF 1 after manual OFF 0");
    #endif
  }
}

//************Функция обработки входящих сообщений от шлюза************

void receive(const MyMessage &message)
  {
    if (message.type == V_STATUS)               // Если сообщение для датчика типа V_STATUS
    {
   if (message.sensor < CH)                     // Если сообщение для реле
    {
                                                // Установить входящее сообщение в параметр состояние
      MySwitch[message.sensor].state = message.getBool(); // getBool - отдает только 0 или 1
                                                // Отправить в функцию выключателя, номер канала и состояние
      doSwitch(message.sensor, MySwitch[message.sensor].state);
     #ifdef SERIAL_DEBUG                        // Обработка ошибок через com порт
     Serial.print("Incoming change for sensor:");
     Serial.print(message.sensor);
     Serial.print(", New status: ");
     Serial.println(message.getBool());
     #endif
      }
    if (message.sensor == NCHANNEL_ID)          // Если сообщение для ID канала
    {
      channelid = message.getInt();             // Установим переменную канала из сообщения
      if (channelid > 125)                      // Если переменная канала больше 125
      {
        channelid = 76;                         // Установим канал 76
        saveState(200, channelid);              // Сохраним переменную канала в ячейку 613
        wait(500);                              // Подождем 500 мс
        send(msgCH.set(channelid));             // Отправим номер канала
        wait(3000);                             // Подождем 3 сек
        softReset();                            // Перезагрузка
      }
      else                                      // Если переменная канала до 125
      {
        saveState(200, channelid);              // Сохраним переменную канала в ячейку 613
        wait(500);                              // Подождем 500 мс
        send(msgCH.set(channelid));             // Отправим номер канала
        wait(3000);                             // Подождем 3 сек
        softReset();                            // Перезагрузка
      }
    }
    if (message.sensor == NODE_ID)              // Если сообщение для ID ноды
    {
      nodeid = message.getInt();                // Установим переменную ID ноды из сообщения
      hwWriteConfig(EEPROM_NODE_ID_ADDRESS, nodeid); //Записываем ID ноды в ячейку 0
      send(msgID.set(nodeid));                  // Отправим ID ноды
      wait(500);                                // Подождем 500 мс
      softReset();                              // Перезагрузка
    }
  }
    if (message.type == V_WEIGHT)               // Если сообщение для таймеров "auto_off"
    {
                                                // Установить входящее сообщение в параметр таймера
      MySwitch[message.sensor-CH].auto_off = message.getByte(); // getByte - отдает числа 0-255
                                                // Сохранить состояние датчика в EEPROM (положение == номер датчика)
      saveState( message.sensor, MySwitch[message.sensor-CH].auto_off);
                                                // Обновим параметры канала
      //MySwitch[message.sensor-CH].auto_off = ((unsigned long)MySwitch[message.sensor].auto_off);
      #ifdef SERIAL_DEBUG
      Serial.print("Off time is set ch");
      Serial.println(message.sensor - CH);
      Serial.print(MySwitch[message.sensor-CH].auto_off);
      Serial.println(" min");
      #endif
  }
    if (message.type == V_FLOW)                 // Если сообщение для таймеров "timer"
    {
                                                // Установить входящее сообщение в параметр таймера
      MySwitch[message.sensor-CH-CH].timer = message.getByte(); // getByte - отдает числа 0-255
                                                // Сохранить состояние датчика в EEPROM (положение == номер датчика)
      saveState( message.sensor, MySwitch[message.sensor-CH-CH].timer);
                                                // Обновим параметры канала
      //MySwitch[message.sensor-CH-CH].timer = ((unsigned long)MySwitch[message.sensor].timer);
      #ifdef SERIAL_DEBUG
      Serial.print("Timer ");
      Serial.println(message.sensor - CH - CH);
      Serial.print(MySwitch[message.sensor-CH-CH].timer);
      Serial.println(" min");
      #endif
    }
    if (message.type == V_VAR1)                 // Если сообщение для датчика типа V_VAR1
    {
    if (message.sensor == 250)                  // Если сообщение номер канала для всех
    {
      channelid = message.getInt();             // Установим переменную канала из сообщения
      if (channelid > 125)                      // Если переменная канала больше 125
      {
        channelid = 76;                         // Установим канал 76
        saveState(200, channelid);              // Сохраним переменную канала в ячейку 613
        wait(500);                              // Подождем 500 мс
        send(msgCH.set(channelid));             // Отправим номер канала
        wait(3000);                             // Подождем 3 сек
        softReset();                            // Перезагрузка
      }
      else                                      // Если переменная канала до 125
      {
        saveState(200, channelid);              // Сохраним переменную канала в ячейку 613
        wait(500);                              // Подождем 500 мс
        send(msgCH.set(channelid));             // Отправим номер канала
        wait(3000);                             // Подождем 3 сек
        softReset();                            // Перезагрузка
      }
    }
  }
}

//********************Функция перезагрузки устройства******************

void softReset()
{
  asm volatile ("  jmp 0");
}
